#!/usr/local/bin/perl -w
#------------------------------------------------------------------------------
# $Id: grant.pl,v 1.2 2002/10/08 16:12:29 manager Exp $
#------------------------------------------------------------------------------
# $Log: grant.pl,v $
# Revision 1.2  2002/10/08 16:12:29  manager
# - use strict
# - manpage added
#
# Revision 1.1  2002/10/08 15:01:02  manager
# Initial revision
#
#------------------------------------------------------------------------------
# grant full privileges for a table for a given user
# afb 5/97
# im 12/98
#------------------------------------------------------------------------------

=head1 NAME

grant -- grant full privileges for a MySQL database for a given user

=head1 SYNOPSIS

B<grant> I<datadir> I<dbname> I<login>

=head1 DESCRIPTION

B<grant> modifies the meta database of the MySQL database
residing under I<datadir> such that I<login> has full privileges
on I<dbname>.

=head1 AUTHOR

Andreas Borchert

=cut

use strict;
use English;
use Mysql;
use Mysql::Admin;

#------------------------------------------------------------------------------
# command line
#------------------------------------------------------------------------------
my $cmdname = $0; $cmdname =~ s{.*/}{};
my $usage = "Usage: $cmdname datadir dbname login\n";
die $usage unless @ARGV == 3;
my ($datadir, $dbname, $login) = @ARGV;

#------------------------------------------------------------------------------
# grant privilege
#------------------------------------------------------------------------------
my @stmts = ();
my $sql_statement = "insert into db values ('localhost', '$dbname', '$login'";
foreach (1..10) { $sql_statement .= ", 'Y'" }
$sql_statement .= ")";
push(@stmts, $sql_statement);

$sql_statement = "insert into user values ('localhost', '$login', ''";
foreach (1..14) { $sql_statement .= ", 'Y'" }
$sql_statement .= ")";
push(@stmts, $sql_statement);

Mysql::Admin::setenv($datadir);
my $db = Mysql->connect();
$db->selectdb("mysql");
foreach my $stmt (@stmts) {
   $db->query($stmt) || die "$cmdname: unable to execute $stmt\n";
}
